
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>分布式系统测试在阿里云的实践 / iVAN</title>

    <meta name="description" content="分布式系统测试在阿里云的实践 分布式系统的测试是一个比较大的话题,在这里,我们仅用几个阿里云飞天分布式系统测试中比较有特点的实践方式来阐述一下我们对分布式系统测试的理解,希望对大家有所帮助. 1. 阿里云的分布式系统 飞天是阿里云独立开发的大规模分布式计算与存储系统,兼有分布式存储和分布式计算的多重功能.基于飞天大规模分布式系统,我们开发了弹性计算,海量邮箱服务,Key-Value存储引擎,结构化数据存储引擎和海量数据处理服务等一系列的上层服务,并且基于这些上层服务,我们运营了了Open Table Service和Open">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">分布式系统测试在阿里云的实践</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>分布式系统的测试是一个比较大的话题，在这里，我们仅用几个阿里云飞天分布式系统测试中比较有特点的实践方式来阐述一下我们对分布式系统测试的理解，希望对大家有所帮助。</p>
<p>1. 阿里云的分布式系统</p>
<p>飞天是阿里云独立开发的大规模分布式计算与存储系统，兼有分布式存储和分布式计算的多重功能。基于飞天大规模分布式系统，我们开发了弹性计算，海量邮箱服务，Key－Value存储引擎，结构化数据存储引擎和海量数据处理服务等一系列的上层服务，并且基于这些上层服务，我们运营了了Open Table Service和Open Storage Service等多项开放服务。</p>
<p>2. 测试的层次结构</p>
<p>按照层次和功能，测试可以分为单元测试，功能测试，系统测试，集成测试，端到端测试等若干种测试。这里首先要提的是单元测试，单元测试更像是一种预防代码错误的手段，而不是检测代码错误的手段，我们用覆盖率（包括行覆盖和分支覆盖）来检验单元测试的质量。当然我们也都知道这些指标不能作为单元测试好坏的标准，所以，在项目中，我们也非常注重代码审查，其中包括了单元测试代码的审查。</p>
<p>传统的一般来说，一个产品一般只有对外接口进行功能测试和系统测试，但是由于飞天的代码非常的复杂，模块非常多，每个模块都具有了一个产品的复杂度。所以，我们在模块层面也会进行功能测试和系统测试，为的是保证系统质量能够得到回归，在有代码修改的时候，影响上层业务使用的接口或者隐含逻辑一旦发生变化，能够第一实践知晓。功能测试非常注重对接口函数的覆盖，并且会对各种参数的边界进行复杂的探测，而系统测试比较注重稳定性，一致性，性能甚至容灾能力等各个方面。</p>
<p>在飞天系统内部，有专门的集成测试部门，集成测试团队有一个非常大的责任是通过回归测试用例来保证系统中的各个模块，在版本发布时在一起能够很好的工作，并对之前每个模块定下的质量验收标准进行验证。一旦发现重大风险，集成测试部门有权力不发布其中某些Feature，如果这个Feature有某种重要的商业用途，则进行推迟整体版本的发布。这一点可能和传统软件不太一样。当分布式软件已经比较成熟的时候，底层很多模块的Feature在某个版本的删减，大多数时候不会影响到用户的正常使用，但是如果由于这个Feature的发布导致分布式系统出现不稳定或者性能大幅下降，则得不偿失。</p>
<p>端到端测试在内部有个简洁的名字叫做E2E Testing。E2E Testing的责任人需要负责向上层使用这个模块或者系统的用户方了解具体的需求，这个需求不仅是一个对接口功能的需求，还包含了数据量的需求，机器规模的需求，吞吐率的需求，延迟时间的需求以及业务量在一天或者一周内的曲线等等信息，然后设计E2E的测试程序，能够尽可能的模拟真实的数据情况。在本身上层业务就已经有数据的情况下，还可以通过导入真实业务的数据进行测试。通过长时间的E2E测试，验证各种指标。</p>
<p>一般来说，我们只有在通过了最后的E2E测试之后才能发布版本，上线让应用使用我们的分布式系统。</p>
<p>3. 注重探索式测试</p>
<p>分布式系统的测试非常的复杂，你既无法通过穷举来罗列所有的情况，也不能简单的对接口和性能进行回归来证明一个版本的合格。因为对于分布式系统，不同的数据量，不同的压力，不同的机器规模，有可能在代码里面走的路径完全不一样。而且，由于在大的压力下，磁盘，内存和网络有可能成为系统的瓶颈。更有甚者，在压力不均匀的情况下，单台机器可能会成为整个系统的瓶颈。所以，我们是没有办法设计这么多的测试用例来分别覆盖所有的这些分支情况的。</p>
<p>我们有详细的监控系统可以监控整个集群的各种参数，这些参数不光是硬件参数，更多的是软件本身通过调用我们监控系统的API来完成对自身某些指标的统计。这些统计不光在线上系统能够起到监控的作用，执行测试的人员可以通过不断改变测试的各项参数，结合这些指标的变化进行探索式的测试。通常，通过指标在某些压力变化下或者随着时间推移时的异常行为，测试人员会更容易找到一些深藏的Bug。另外，在系统级测试时，通过对系统内部Error Log的监控也能达到很好的效果。</p>
<p>4. 灰盒测试是分布式测试的最有效方法</p>
<p>上面讲到了探索式的测试十分重要，但是光有探索，如果测试人员本身不了解系统的一些内部逻辑，会出现两种情况：第一种是，只验证设计好的场景，其他一些异常的情况，自己无法解释，但是本身又不是验证标准，导致很多隐藏的问题最终在线上爆发；第二种是，一个没头的苍蝇，漫无目的的进行探索，最终浪费了时间，却达不到好的效果。在飞天分布式系统测试中，我们要求测试人员必须从方案设计之初甚至是讨论需求的时候就和开发的同学在一起讨论，测试的同学需要比开发更加理解系统的设计原则。</p>
<p>有一个很典型的例子是，早期，我们内部开发一个基于表结构的存储引擎时，曾经出现过这样一件事情：测试程序在最终验证一致性时，一直都是通过的，但是业务方和我们一起做E2E测试的时候，会有很低的概率发现数据读出来是错误的。测试人员百思不得其解，最后发现，这份数据在写入的时候，会先在三个地方进行修改，但是由于一些时序和锁的问题，在改过了两个地方之后就返回成功了，第三个地方是在内存中，过一阵子就会被重新刷成正确的值。如果当时测试的同学知道系统里面这些设计，当时就会设计写入过程中，对数据一致性的检测，不会在用户场景中再发现问题，解决的效率也会因此而提高。</p>
<p>5. 带压力和随机故障模拟的长时间稳定性测试</p>
<p>分布式系统往往是在多台机器上运行多个进程，每个进程都是一个独立主体，运行着自己独立的逻辑，各个进程都有可能因为软硬件故障导致逻辑执行异常。分布式系统要保证的是任何局部的进程异常都不会影响系统的可用性，因此必须要做必要故障模拟和恢复测试。由于进程之间通讯协议的复杂，故障类型的多样，并不能够模拟所有可能出现故障和进程状态的组合，也就是说这样的组合是爆炸的。</p>
<p>在飞天实际的测试过程中，我们采用的是带背景压力和随机故障模拟的长时间稳定性测试。这也是飞天主版本发布的最后一道关。背景压力主要是各个主要模块的读写压力，还有一些诸如CPU，Memory，Network的资源消耗器，以模拟机器资源紧张场景。故障模拟操作又比如磁盘错误，包括坏盘，只读等，机器宕机，重启，断网，主要模块进程重启，假死等，这些操作都会按照预先设定比例进行随机组合；在这样的背景压力和故障操作下，长时间（至少7x24 小时）持续运行上层应用模拟程序/作业。同时通过在线监控工具来检查系统是否正常。飞天很多重要的bug都是通过这个测试被发现的。当然这类测试也有短处，就是问题调查需要较长的时间，要求测试人员对系统有较深的了解和诊断能力。</p>
<p>6. 如何保障测试的质量</p>
<p>单元测试虽然可以用Coverage工具来检验行覆盖和分支覆盖，但是功能测试和系统测试在运行时，进程运行在上百上千台机器上，很难通过既有的软件来搜集到coverage数据。我们内部开发了一个叫做Log Coverage的工具，能够通过程序在运行过程中输出的Log信息的多少来判断测试是否有足够的覆盖率。通过拿到生产线上的Log与测试中的Log进行比较，会找到我们之前没有测试到的地方。另外，通过对程序中从来没有打印出的Error Log的检查，我们也可以知道有多少异常逻辑我们没有测试过。</p>
<p>(责任编辑：蒙遗善)</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 17:40:18</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e9%98%bf%e9%87%8c%e4%ba%91/" title="阿里云">阿里云</a>, <a href="https://www.iamivan.net/tag/%e9%a3%9e%e5%a4%a9/" title="飞天">飞天</a>, <a href="https://www.iamivan.net/tag/%e6%88%91%e4%bb%ac/" title="我们">我们</a>, <a href="https://www.iamivan.net/tag/%e8%bf%99%e4%ba%9b/" title="这些">这些</a>, <a href="https://www.iamivan.net/tag/%e9%80%9a%e8%bf%87/" title="通过">通过</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>分布式系统测试在阿里云的实践的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zeoQ1OM.html" rel="bookmark">十问够快网络 答疑阿里云平台实践之路</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是十问够快网络 答疑阿里云平台实践之路,云计算已经被众多的厂商视为一块肥肉,纷纷下血本投入到这个行业中.国内比较大的云平台服务商包括阿里云.盛大云.百度云.新浪云和华为云.他们都在推出自己产品和服务,谋求在云计算时代引领行业发展. 当然任何的产品和服务都离不开用户的支持,作为阿里云平台的核心用户之一,够快网络是阿里云平台的一个实践者,今天我们IT168有幸采访到了够快网络的技术负责人蒋烁淼,他从用户的角度分析了阿里云平台的技术特点以及使用体验,给用户选择云平台提供了很好的参考. ▲够快网			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqAk8OM.html" rel="bookmark">一分钟了解阿里云产品：墨迹天气之阿里云MaxCompute实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  墨迹天气成立到现在5年多,已经积累了4亿用户.同时,在墨迹天气上,每天有超过 5 亿次的天气查询需求.墨迹天气已经集成了多语言版本,可根据手机系统语言自动适配,用户覆盖包括中国大陆.港澳台,日韩及东南亚.欧美等全球各地用户.运营团队每天最关心的是这些用户正在如何使用墨迹,在他们操作中透露了哪些个性化需求.     这些数据全部存储在墨迹的API日志中,墨迹天气的API每天产生的日志量大约在400GB左右,分析工具采用了阿里云的大数据计算服务MaxCompute.   使用MaxCompute			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z40Zvjz.html" rel="bookmark">JEESZ分布式架构集成阿里云OSS存储</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				摘要: 1. 服务接口定义 /**  * 文件上传  1:头像 2:显示图片 3:个人封面  :4:基础图片   * @param request  * @param response  * @param uid 用户id  * @param userType 文件上传  1:头像 2:显示图片 3:个人封面  :4:基础图片 0:视频  * @param files 上传的文件对象  * @return  1. 服务接口定义 /**  * 文件上传  1:头像 2:显示图片 3:个人封面  :			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvGgj1p.html" rel="bookmark">小鱼儿CTO赵兴国：基于阿里云的互联网&plus;视频会议系统实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2016云栖大会上海峰会于2016.1.20日在上海科技馆顺利举办.本文是根据小鱼儿科技联合创始人兼CTO赵兴国在2016云栖大会上海峰会&lt;互联网+架构及实践专场&gt;的演讲中分享内容整理而成.赵兴国以基于阿里云后台的视频会议系统为例,分享了互联网+的视频会议实践.   下面是演讲内容整理.   传统视频会议设备复杂,一般是四件套,会议系统必须外接电视.麦克风.摄像头,学习很复杂的摇控器,才能够开始使用.为保障视频会议效果,还需要搭建服务器.租专线,才能投入使用.并且每次开会都需要专业人员维护,比			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boRXGgz.html" rel="bookmark">阿里云「最佳上云实践」征文大赛获奖文章公布</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 云计算时代,越来越多的企业应用和个人网站步入云端.与传统的方式相比,云计算可以让你从繁重的基础设施购置与维护中解放出来,从而专注于产品的开发和运营. 在征文阶段,共有近100个企业和开发者提交了上云实践现文章,经过初选,有61篇文章进入投票阶段,经过广大网友的投票(投票页面:https://yq.aliyun.com/activity/158)以及专家评审团的打分,结果公布如下.   一等奖: 新浪微博:极端流量下的峰值应对与架构挑战 二等奖: 吉利LYNK&amp;CO+阿里云:汽车行业新零售模式的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDYGgvb.html" rel="bookmark">【技术干货】阿里云构建千万级别架构演变之路</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文作者:乔锐杰,现担任上海驻云信息科技有限公司运维总监/架构师.曾任职过黑客讲师.java软件工程师/网站架构师.高级运维.阿里云架构师等职位.维护过上千台服务器,主导过众安保险.新华社等千万级上云架构.在云端运维.分布式集群架构等方面有着丰富的经验. 前言     一个好的架构是靠演变而来,而不是单纯的靠设计.刚开始做架构设计,我们不可能全方位的考虑到架构的高性能.高扩展性.高安全等各方面的因素.随着业务需求越来越多.业务访问压力越来越大,架构不断的演变及进化,因而造就了一个成熟稳定的大型架			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDeKRXb.html" rel="bookmark">阿里云容器服务飞天敏捷版详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 飞天敏捷版深度整合了Docker商业版套件和阿里的容器服务,成为国内唯一具有全商业版支持能力的容器云平台,可以部署在客户自有数据中心,包含从容器的创建到运行以及镜像的全生命周期管理.飞天敏捷版另外提供开放的接口,全面兼容Docker原生API和命令行以及第三方工具,为客户提供敏捷.弹性.开放的容器云平台.借助阿里云在公共云和专有云方面的积累,飞天敏捷版更提供了独特的混合云管理模式,让客户轻松管理云上云下运行环境. 飞天敏捷版的架构可以用下图表示: 从图中我们可以看到,飞天敏捷版底层基于Do			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkAWWOb.html" rel="bookmark">一分钟了解阿里云产品：大数据计算服务MaxCompute概述</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  阿里云发布了许多产品,今天让我们来了解下大数据计算服务MaxCompute这款产品吧.     什么是MaxCompute呢?   MaxCompute是由阿里云自主研发,是阿里巴巴自主研发的海量数据处理平台.提供针对TB/PB级数据.实时性要求不高的分布式处理能力,应用于数据分析.挖掘.商业智能等领域.主要服务于批量结构化数据的存储和计算,可以提供海量数据仓库的解决方案以及针对大数据的分析建模服务.阿里巴巴的离线数据业务都运行在MaxCompute上.   MaxCompute有什么优势和			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJZl7Jz.html" rel="bookmark">用Windows IIS和阿里云NAS提供Web和FTP服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				阿里云文件存储服务NAS(阿里云NAS)是阿里云在2016年正式推出的公有云上的网络文件系统实现.阿里云NAS主要面向阿里云 ECS 实例.HPC.Docker.弹性Web和BatchCompute 等计算节点提供文件存储服务.通过标准的文件访问协议,用户无需对现有应用做任何修改,即可在云上使用具备无限容量及性能扩展.单一命名空间.多共享.高可靠和高可用等特性的分布式文件系统.阿里云于2016年发布了支持NFS网络文件系统访问协议的阿里云文件系统(NAS).2017年3月,又增加了SMB文件系统			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpn8nKb.html" rel="bookmark" class="title">ORIGAMI五分钟零基础入门秘籍</a>
					<div>
						  Facebook新推出的Origami插件非常强大,配合Sketch可以非常方便的搞定Demo动画.鉴于国内几乎没有教程,今天腾讯同学整理了一份Origami入门文档,就算是零基础也可以迅速上手, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMR8Dqz.html" rel="bookmark" class="title">取余赋值运算符 &lpar;％&equals;&rpar;</a>
					<div>
						运算   变量值除以表达式值,并将余数赋给变量. result %= expression 参数 result 任何变量. expression 任何数值表达式. 说明 使用 %= 运算符与使用下面的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPvN1b.html" rel="bookmark" class="title">用Fireworks制作动画</a>
					<div>
						制作网页动画可用许多种方法来实现,如:用Java或DHTML或Flash等,也可用Fireworks.而Fireworks提供了三种制作动画的手段:手工绘制.使用符号(Symbol).图像法.     ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgY53z.html" rel="bookmark" class="title">ASP&period;NET 2&period;0&OpenCurlyDoubleQuote;插件&rdquo;说</a>
					<div>
						asp.net ASP.NET 2.0&quot;插件&quot;说 在 ASP.NET 2.0的新特性中,最&quot;耀眼&quot;的也就是母版页.主题/皮肤.成员资格和角色管理.用户自定义属性 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boB7Dz.html" rel="bookmark" class="title">网站优化犹如画圆  找准圆心半径很重要</a>
					<div>
						2011年1月20日,也是中国传统节日农历春节前夕,网民期待已久的Google PR更新姗姗来迟,大面积的更新了网站PR值,传说中的PR已经停止更新的谣言不攻自破.继PR更新之后,国内第一大中文搜索引 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6n0LM.html" rel="bookmark" class="title">用户体验&colon;用户行为研究</a>
					<div>
						用户行为研究主要的工作就是研究用户的行为,通过对用户行为的研究来更好的了用户.了解需求. 在互联网产品中,用户访问我们的网站,我们来设计我们的网站.一个关键的问题是,我们如何能够了解我们的用户,他们是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M0jZmz.html" rel="bookmark" class="title">外贸SEO如何应对谷歌排名算法的频繁调整</a>
					<div>
						谷歌在2012年一如既往的加强了对搜索质量的调整.首当其冲的是我们国内从事外贸电子商务的企业和网站.外贸SEO已经不能像过去一样采用外链策略去提高排名了,而是需要采用整站优化的方式去做流量和关键词排名 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AArBp.html" rel="bookmark" class="title">修补AJAX应用中Back&sol;Forward Button和Bookmark失效的问题</a>
					<div>
						想法与目标 从AJAX诞生至今,就存在着Back/Forward Button和bookmark失效的问题,我 以前一般提倡,一个好的AJAX应用应该不让用户有点击&quot;Back/Forward ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKEZ6M.html" rel="bookmark" class="title">CSS让网页更容易设计与维护</a>
					<div>
						CSS语法立意让网页内容与视觉呈现分离,一方面使得页面维护工作更容易,不会因内容或视觉效果改变影响到另一方,这样的页面设计,也对搜寻引擎更为友善,更容易搜寻到页面内容. CSS,Cascading S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY2LwBp.html" rel="bookmark" class="title">如何在编辑框中使用IAutoComplete接口</a>
					<div>
						唉!,就叫我封装先生吧. 你算是找对地方了.但是我要先声明我的解决办法不是你所希望的-甚至也不是我自己所希望的! 什么是autocomplete呢?你也许已经注意到当你在IE的地址编辑框中敲入什么东西 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGjPvnp.html" rel="bookmark" class="title">IsLine FrameWork系列之十一--HttpContentProvider访问缓存</a>
					<div>
						今天我们来介绍 IsLine.HttpContent.HttpContentProvider命名空间: 这个Provider主要封装了对缓存.Session与Cooike的操作,该空间下主要有三个类: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLOEPWM.html" rel="bookmark" class="title">联想Legion Y720游戏本上手评测</a>
					<div>
						  联想最近推出了一款专为VR游戏打造的LenovoLegion游戏设备--LegionY720. 这款笔记本可以让游戏转换成VR的形式,并且配备霸气的外观设计,搭载15.6英寸屏幕和英特尔I5 -7 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z729gXp.html" rel="bookmark" class="title">PHP实现linux命令tail -f&lowbar;php实例</a>
					<div>
						tail 命令从指定点开始将文件写到标准输出.使用tail命令的-f选项可以方便的查阅正在改变的日志文件,tail -f filename会把filename里最尾部的内容显示在屏幕上,并且不但刷新, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkwLNwp.html" rel="bookmark" class="title">一个草根如何从身无分文到月收入过万</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 大家好,我是勾陈,,前一段时间写了一些关于如何寻找项目以及如何利用seo进行赚钱的思路文章之后,有不少的朋友加我为好友,这让我认识了很多的朋友,这里我就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0QrmDp.html" rel="bookmark" class="title">【原创】Python 之快速性能优化（第一部分）</a>
					<div>
						本文为翻译, 原文地址:&lt; Quick Python Performance Optimization: Part I &gt;  This is part I of a two part se ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV06gKM.html" rel="bookmark" class="title">如果一个网站改版之后出现不少问题，应该怎么办！</a>
					<div>
						问题描述 我有一个网站www.caizicheng.com改版了两次,现在出现百度排名没有了,文章收录了,当是总收录数却没有变.网站的刚更新的页面有排名,当是首页没有排名.现在我应该怎么做?改版时做个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRGqEb.html" rel="bookmark" class="title">【干货】ModSecurity - 针对中小站长高效、免费waf组件</a>
					<div>
						ModSecurity  p.s. 因发帖规定,所有http前面都加了@哦~  原创作者:雷息  一.简介   ModSecurity是一款免费的开源主机waf软件(@http://www.modse ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGZnWop.html" rel="bookmark" class="title">斯库利：不是我赶走乔布斯 20多年从未联系</a>
					<div>
						导语:苹果前CEO约翰·斯库利(John Sculley)近日在接受采访时表示,史蒂夫·乔布斯(Steve Jobs)当时被赶出苹果公司是董事会的决定,他本人不应为此承担责任.斯库利还称,他并不希望与 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baBZngM.html" rel="bookmark" class="title">编程-我要写一个通讯录的程序，要有分组的功能，怎么实现比较好。</a>
					<div>
						问题描述 我要写一个通讯录的程序,要有分组的功能,怎么实现比较好. 如题,用户可以自由添加或删除分组,一个人可以属于多个不同组 解决方案 要使用两个表: 表一.字段:排序,分组,姓名,性别,办公电话, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlB1qp.html" rel="bookmark" class="title">基于iframe实现ajax跨域请求 获取网页中ajax数据&lowbar;AJAX相关</a>
					<div>
						大家都知道,在不同域的情况下是不能发送ajax请求的,浏览器会报如下错误: 同时,内嵌的iframe中无法进行跨域通信的,也就是说不同域的iframe是无法互相读取数据的(当然利用hash变化可以从父 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkGQAM.html" rel="bookmark" class="title">TypeScript Type Innference&lpar;类型判断&rpar;&lowbar;javascript技巧</a>
					<div>
						TypeScript 是微软开发的 JavaScript 的超集,TypeScript兼容JavaScript,可以载入JavaScript代码然后运行.TypeScript与JavaScript相比 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3ZqRWz.html" rel="bookmark" class="title">jquery 获取自定义属性&lpar;attr和prop&rpar;的实现代码&lowbar;jquery</a>
					<div>
						1. attr(属性名) //获取属性的值(取得第一个匹配元素的属性值.通过这个方法可以方便地从第一个匹配元素中获取一个属性的值.如果元素没有相应属性,则返回 undefined ) 2. attr( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bByKDaz.html" rel="bookmark" class="title">黑客之王！韩国神童登顶黑客界的&OpenCurlyDoubleQuote;极限挑战&rdquo;</a>
					<div>
						现场不允许拍照,所有的竞赛题目和技术分享都不能泄露.这就是黑客大师赛 WCTF 散发出的的&quot;黑客气质&quot;. 所谓 CTF,就是黑客界流行的一种竞赛.大致来说就是各大战队依靠自己的独门 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2YnxZz.html" rel="bookmark" class="title">Hifn容量优化卡成功支持Bull公司备份方案</a>
					<div>
						   Hifn近日宣布,欧洲IT公司Bull已选择将Hifn的新型Express DR 650数据缩减卡集成于该公司新近上市的StoreWay Virtuo V7备份/存储与磁带虚拟解决方案.Hifn ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8gg3NM.html" rel="bookmark" class="title">Instagram澄清隐私新政：无意出售用户照片</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 Instagram CEO凯文•斯特罗姆在题为&quot;谢谢大家,我们在倾听&quot;的博文中写道:需要澄清一点的是,我们无意出售您的照片. 新浪科 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlWxw8b.html" rel="bookmark" class="title">Java反射机制与应用</a>
					<div>
						    JAVA反射机制     JAVA反射机制是在运行状态中,对于任意一个类,都能够知道这个类的所有属性和方法:对于任意一个对象,都能够调用它的任意一个方法:这种动态获取的信息以及动态调用对象的方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ3r76b.html" rel="bookmark" class="title">柳传志自评海外并购：买到3样想买的东西</a>
					<div>
						买到3样想买的东西,站在转折点上 马可佳 全场长时间持续的掌声,仅是因为柳传志的发言又一次显露了&quot;大佬&quot;本色. 7月4日,2009年全球智库峰会&quot;跨国公司在金融危机中的合 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNO58yp.html" rel="bookmark" class="title">&lbrack;DOM&rsqb;javascript DOM操作</a>
					<div>
						对于B/S开发,客户端与服务器端的交互是非常必要的,JavaScript的提出解决了很多问题,AJAX的提出也解决了异步通信的问题,更加为用户着想了.而DOM是其中非常基础的知识,在学习AJAX的同时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxgVjOb.html" rel="bookmark" class="title">我的网站的首页怎么不刷新啊 ？求高手指教</a>
					<div>
						问题描述 大家好,前段时间自己经营了一个网站,由于嫌进入网页的速度过慢找了一个代码优化软件优化了一下,前几天没注意,今天我更新软件的时候只在分页上更新了,但是网站首页怎样更新也不显示最新的内容,求高手 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPXPg0p.html" rel="bookmark" class="title">宜宾市网络书屋开通率达到100&percnt;</a>
					<div>
						中广网宜宾3月15日消息(记者隆敏 通讯员金萍)记者从3月14日在兴文县召开的推进科普网络书屋建设会上获悉,今年兴文县.翠屏区.南溪区.高县.长宁县.珙县6个区县实现科普网络书屋开通基本目标,力争屏山 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
